IMPLEMENTATION MODULE Plot;
FROM InOut IMPORT WriteString, WriteLn, WriteInt;
FROM MathLib0 IMPORT entier;
FROM RealInOut IMPORT WriteReal;

PROCEDURE PlotReal(XStart, XFinish: REAL; F: RealFunc);

CONST XSize = 78;
      YSize = 22;
      Blank = ' ';

TYPE Matrix = ARRAY[0..YSize],[0..XSize] OF CHAR;

VAR X, Y, DeltaX, DeltaY : REAL;
    Output : Matrix;
    Ymin, Ymax: REAL;
    I, J   : INTEGER;

BEGIN
  (* Initialize the matrix *)
  FOR I := 0 TO YSize DO
    FOR J := 0 TO XSize DO
      Output[I,J] := Blank;
    END
  END;

  DeltaX := (XFinish - XStart) / FLOAT(XSize);
  Ymin := F(XStart); Ymax := F(XStart);
  FOR J := 1 TO XSize DO
    X := XStart + DeltaX * FLOAT(J);
    IF    F(X) < Ymin THEN Ymin := F(X)
    ELSIF F(X) > Ymax THEN Ymax := F(X)
    END;
  END;
  DeltaY := (Ymax -Ymin) / FLOAT(YSize+1);

  (* Fill in the matrix *)
  FOR J := 0 TO XSize DO
    X := XStart + DeltaX * FLOAT(J);
    Y := F(X);
    I := entier((Ymax-Y)/DeltaY);
    IF    I > YSize THEN I := YSize;
    ELSIF I < 0 THEN I := 0;
    END;
    Output[I, J] := '+';
  END;

  (* Print the matrix *)
  FOR I := 0 TO YSize DO
    FOR J := 0 TO XSize DO
      WriteString(Output[I,J]);
    END;
    WriteLn;
  END;
END PlotReal;

END Plot.


