IMPLEMENTATION MODULE TreeStuff;
(* MODULA-2 Programming with Data Structures, by B. K. Walker, pp 284-286 *)

FROM Storage IMPORT ALLOCATE, DEALLOCATE;
FROM InOut IMPORT WriteInt;

TYPE BINTREE = POINTER TO TreeNode;
     TreeNode = RECORD
                  data: INTEGER;
                  left,
                  right: BINTREE;
                END;

PROCEDURE AddBinTree (VAR T: BINTREE; NewData: INTEGER);
BEGIN
  IF T = NIL THEN
     NEW (T);
     T^.data := NewData;
     T^.left := NIL;
     T^.right := NIL;
  ELSE
    IF NewData < T^.data THEN
       AddBinTree (T^.left, NewData)
    ELSE 
       AddBinTree (T^.right, NewData)
    END
  END;
END AddBinTree;

PROCEDURE LNRBin (T: BINTREE);
BEGIN
  IF T <> NIL THEN
     LNRBin(T^.left);
     WriteInt(T^.data, 10);
     LNRBin(T^.right);
  END;
END LNRBin;

PROCEDURE InitBinTree (VAR T: BINTREE);
BEGIN
  T := NIL;
END InitBinTree;

PROCEDURE IsBinTreeEmpty (T: BINTREE): BOOLEAN;
BEGIN
  IF T = NIL THEN 
     RETURN TRUE
  ELSE
     RETURN FALSE;
  END;
END IsBinTreeEmpty;

END TreeStuff.


