MODULE ProcTest;

FROM TreeStuff IMPORT
                        AddBinTree,
                        LNRBin,
                        BINTREE,
                        InitBinTree;
FROM InOut IMPORT
                        Read,
                        WriteLn,
                        WriteString,
                        WriteInt;
FROM RandomStuff IMPORT
                        Randu;
FROM Kernel IMPORT
                        SignalHeader,
                        Signal,
                        Wait,
                        InitSignal,
                        NewProcess;
VAR
        T: BINTREE;
        DataClear, DataReady, Finished: SignalHeader;
        data: INTEGER;
        ch: CHAR;
        Stop: BOOLEAN;
        Flag: BOOLEAN;

PROCEDURE TreeIt;
  BEGIN
    LOOP
      WriteString('TreeIt loop');
      IF Stop THEN Signal(Finished); END;
      IF NOT Flag THEN
        WriteString('TreeIt will wait DataReady!'); WriteLn;
        Wait(DataReady);
      END;
      WriteString('Adding ');
      AddBinTree(T, data);
      WriteInt(data,10); WriteLn;
      Flag := FALSE;
      WriteString('TreeIt signaling DataClear!'); WriteLn;
      Signal(DataClear);
    END;
  END TreeIt;

PROCEDURE MakeData;
  BEGIN
    LOOP
      IF Stop THEN Signal(Finished); END;
      WriteLn;
      WriteString ('M (ake) P(rint) Q(uit)');
      Read(ch);
      WriteLn;
      ch := CAP(ch);
      CASE ch OF
        'M':    IF Flag THEN
                   WriteString('MakeData is waiting DataClear!');
                   WriteLn;
                   Wait(DataClear);
                END;
                data := INTEGER(Randu());
                Flag := TRUE;
                Signal(DataReady);
                WriteString('Created data '); WriteInt(data, 10); WriteLn; |
        'P':    WriteLn;
                WriteString('tree follows: ');
                WriteLn;
                LNRBin(T); |
        'Q':    Stop := TRUE;
        ELSE
                WriteString(' did not recognize command ');
                WriteLn;
        END;
      END;
  END MakeData;

BEGIN
        Stop := FALSE;
        Flag := FALSE;
        IF Flag THEN WriteString('Flag is TRUE')
        ELSE WriteString('Flag is FALSE'); END;
        WriteLn;

        InitBinTree(T);
        InitSignal(DataReady);
        InitSignal(Finished);
        InitSignal(DataClear);
        NewProcess(TreeIt, 1400, FALSE);
        WriteString('TreeIt process started!'); WriteLn;
        NewProcess(MakeData, 1400, FALSE);
        WriteString('MakeData process started!'); WriteLn;
        Wait(Finished);
END ProcTest.






